package com.springboot.jpa.auditing.bootstrap;

import com.github.javafaker.Faker;
import com.springboot.jpa.auditing.entity.Product;
import com.springboot.jpa.auditing.service.ProductService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.context.annotation.Configuration;

import java.util.ArrayList;
import java.util.List;

//spring annotation
@Configuration
public class DefaultProductsLoader implements CommandLineRunner {

    @Autowired
    Faker faker;
    @Autowired
    ProductService service;

    @Override
    public void run(String... args) {
        final List<Product> products = createProductList();
        service.saveAll(products);
    }

    //create the product list
    private List<Product> createProductList() {
        final List<Product> products = new ArrayList<>();
        for (int i = 0; i < 5; i++) {
            products.add(create());
        }

        return products;
    }

    //create the product
    private Product create() {
        return Product.builder()
                .productName(faker.commerce().productName())
                .material(faker.commerce().material())
                .price(faker.commerce().price())
                .promotionCode(faker.commerce().promotionCode())
                .build();
    }
}
