package com.springboot.jpa.auditing.entity;

import com.springboot.jpa.auditing.audit.Auditable;
import lombok.*;
import org.springframework.stereotype.Component;

import javax.persistence.*;

//lombok annotations
@Data
@EqualsAndHashCode(callSuper = false)
@NoArgsConstructor
@AllArgsConstructor
@Builder
//spring jpa annotations
@Entity
@Table(name = "product")
//spring annotation
@Component
public class Product extends Auditable<String> {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    int id;
    @Column(name = "product_name", nullable = false)
    String productName;
    String material;
    String price;
    @Column(name = "promotion_code")
    String promotionCode;

}
